{%- if __iterate is undefined %}
  {%- set __iterate = namespace(key={}, len={}, level=0) %}
{#
  {% set __iterate.len = __iterate.len | default({}) %}
  {% set __iterate.level = __iterate.level | int %} 
#}
{%- endif %}
{%- macro iterate(arr, key = '') -%}
  {%- if arr is iterable and arr is not string -%}
    {%- if arr is mapping -%}
      {%- set __iterate.len = __iterate.len | combine({__iterate.level: arr | length}) -%}
      {%- for k, value in arr.items() -%}
        {{ set_filter(value, k) }}
        {%- if value is iterable -%}
          {{ iterate(value, k) }}
        {%- endif -%}
      {%- endfor -%}
    {%- else -%}
      {%- for value in arr -%}
        {{ set_filter(value) }}
        {%- if value is iterable -%}
          {{ iterate(value, key) }}
        {%- endif -%}
      {%- endfor -%}
    {%- endif -%}
  {%- else -%}
  {%- endif -%}
{%- endmacro -%}
{#                          
#}
{% macro set_filter(value, key='', delimeter = ';') -%}
  {%- set __iterate.key = __iterate.key | combine({__iterate.level: key}) -%}
  {%- if value is string -%}
    {{ clean_empty(__iterate) }}
    {% if __iterate.key.get(__iterate.level | int) == 'location' and (__iterate.level | int) > 0 -%}
      {{ set_indent_location() if set_indent(__iterate.key.values()) | int > 5 }}location {{ value }} {  
    {% elif __iterate.key.get(__iterate.level | int) == 'name' -%}
    {% else -%}
      {{ __iterate.key.values() | join('_') | replace('location_', '') | replace('links_', '') | indent(set_indent(__iterate.key.values()) | int, true) }} {{ value }}{{ delimeter }}
    {% endif -%}    
    {{ is_len_null(__iterate) }}
  {%- else -%}
    {%- set __iterate.level = (__iterate.level | int ) + 1 -%}
    {%- set __iterate.len = __iterate.len | combine({__iterate.level: (value | length)}) -%}
  {%- endif -%}
{%- endmacro -%}
{#
#}
{%- macro is_len_null(arr) -%}
  {%- if (arr.len[arr.level] | int) > 0 -%}
    {%- set arr.len = arr.len | combine({ arr.level: (arr.len[arr.level] | int) - 1 }) -%}
  {%- elif (arr.len[arr.level] | int) == 0  -%}
    {%- set arr.key =  arr.key | combine({ arr.level: ''}) -%}
    {%- set arr.level = (arr.level | int ) - 1 -%}
    {%- set arr.len = arr.len | combine({ arr.level: (arr.len[arr.level] | int) - 1 }) -%}
  {%- endif -%}
  {{ close_location(arr) }}
  {%- if (arr.len[arr.level] | int) == 0 and (arr.level | int) > 0 -%}
    {{ is_len_null(arr) }}
  {%- endif -%}
{%- endmacro -%}
{#                          
#}
{%- macro clean_empty(val) -%}
  {%- set tmp_key={} -%}
  {%- for k, v in val.key.items() -%}
    {%- if v %}
      {%- set _ = tmp_key.update({k: v}) -%}
    {%- endif %}
  {%- endfor %}
  {%- set val.key = tmp_key -%}
{%- endmacro -%}
{#                          
#}
{% macro close_location(arr) -%}
  {# close location 
  {{ arr.level }}_locLev#}
  {%- if arr.key.get((arr.level | int) - 1) == 'links' -%}
    {{ set_indent_location() if set_indent(__iterate.key.values()) | int > 5 }}}
  {% endif -%}
{%- endmacro -%}
{%- macro set_indent(val) -%}
  {{ (val | join(" ") | length) - val | join(" ") | replace("links", "") | length | int }}
{%- endmacro -%}
{%- macro set_indent_location(val='') -%}
  {{ val | indent(__iterate.level | int, true, true) }}
{%- endmacro -%}
